<?php

namespace FiloBlu\Omnibus\Model\ConfigurableProduct;

use Magento\Catalog\Api\ProductRepositoryInterface;

class ConfigurableAttributeData extends \Magento\ConfigurableProduct\Model\ConfigurableAttributeData
{

	protected $productRepository;

	public function __construct(
		ProductRepositoryInterface $productRepository,
		\Magento\Catalog\Block\Product\Context $context
	) {
		$this->productRepository = $productRepository;
	}

	/**
	 * @param Attribute $attribute
	 * @param array $config
	 * @return array
	 */
	protected function getAttributeOptionsData($attribute, $config)
	{
		$attributeOptionsData = [];
		foreach ($attribute->getOptions() as $attributeOption) {
			$optionId = $attributeOption['value_index'];
			$productId = isset($config[$attribute->getAttributeId()][$optionId]) ? $config[$attribute->getAttributeId()][$optionId][0] : null;
			$simpleProduct = $productId ? $this->productRepository->getById($productId) : null;

			$attributeOptionsData[] = [
				'id' => $optionId,
				'label' => $attributeOption['label'],
				'products' => isset($config[$attribute->getAttributeId()][$optionId])
					? $config[$attribute->getAttributeId()][$optionId]
					: [],
				'sku' => $simpleProduct ? $simpleProduct->getSku() : ''
			];
		}
		return $attributeOptionsData;
	}
}